#include <stdio.h>
#include <stdlib.h>
#include <pgm.h>

extern unsigned char* read_den( char*, int*, int*, int*);

int main(int argc, char *argv[])
{
  unsigned char *buffervol;
  gray *bufferimg;
  int i, j, sx, sy, sz, ProfondeurCoupe;
  double intensite, max;
  FILE *f;

  if (argc != 4)
    {
    printf("usage: %s <volumename> <imagename> <profondeur de la coupe>\n", argv[0]);
    exit(-1);
    }

  ProfondeurCoupe = atoi(argv[3]);

  buffervol = read_den( argv[1], &sx, &sy, &sz);

  printf("Taille du volume: %d %d %d\n", sx, sy, sz);
  printf("Profondeur de la coupe: %d\n", ProfondeurCoupe);

  if (ProfondeurCoupe<0 || ProfondeurCoupe>=sz) {
    fprintf( stderr, "Erreur: mauvaise profondeur de coupe!\n");
    exit(-1);
  }

  bufferimg = (gray*) malloc(sizeof(gray) * sx * sy);

  max = 0.;

  for (i=0; i<sx; i++)
    {

    for (j=0; j<sy; j++)
      {

      intensite = buffervol[i + j*sx + ProfondeurCoupe*sx*sy];
      bufferimg[i + j * sx] = intensite;
      if (intensite > max) {max = intensite;}
      }
    }

  printf("max intensite = %lf\n", max);

  if ( (f=fopen( argv[2], "w")) == 0) {
    fprintf( stderr, "unable to open file %s\n", argv[2]);
    exit(-1);
  }

  pgm_writepgminit( f, sx, sy, (gray) max, 0);

  fprintf( stdout, "write pgm image\n");

  for (i=0; i<sx; i++)
    pgm_writepgmrow( f, &bufferimg[i*sy], sy, (gray) max, 0);

  fclose(f);
}
